// Check Profiler Javascript and jQuery include file
// Copyright 2016-04-01 Troy Lea aka Box293


// This makes an ajax call synchronous
function check_profiler_ajaxSetup() {
	// I want all ajax calls to be performed synchronously
	$.ajaxSetup({
		async: false,
		cache: false,
		}); // End $.ajaxSetup({
	} // End function check_profiler_ajaxSetup() {


function check_profiler_ToggleMenu(a) {
	// hide all menu elements 
   	$('.check_profiler_togglediv').hide(); 
	// reset the last item that was selected
	$('.check_profiler_menuheading2').addClass("check_profiler_menuheading1").removeClass("check_profiler_menuheading2");
	// show the selected menu element
	$('#' + a).show(); 
	// Style the currently selected menu item
	$('#id_' + a).addClass("check_profiler_menuheading2").removeClass("check_profiler_menuheading1");
	} // End function check_profiler_ToggleMenu(a) {

	
function check_profiler_toggleMe(a) {
	$('#'+ a).slideToggle();
	} // End function check_profiler_toggleMe(a) {


function check_profiler_toggleAll(a) {
	var topics = a.split(':');
	var toggleAllText = $('#expand_collapse').text();
	for (var i=0;i<topics.length;i++) {
		if (toggleAllText == 'Expand All') {
			$('#' + topics[i]).show();
			} // End if (toggleAllText == 'Expand All') {
		else if (toggleAllText == 'Collapse All') {
			$('#' + topics[i]).hide();
			} // End else if (toggleAllText == 'Collapse All') {
		} // End for (var i=0;i<topics.length;i++) {
	if (toggleAllText == 'Expand All') {
		$('#expand_collapse').text('Collapse All');
		} // End if (toggleAllText == 'Expand All') {
	else if (toggleAllText == 'Collapse All') {
		$('#expand_collapse').text('Expand All');
		} // End else if (toggleAllText == 'Collapse All') {
	} // End function check_profiler_toggleAll(a) {


function check_profilerToggleCheckbox(a) {
	//window.alert("value is: " + a);
	if ($('#'+ a).is(':checked')) {
		$(".check_profiler_checkbox").attr('checked', true);
		} // End if ($('#'+ a).is(':checked')) {
	else {
		$(".check_profiler_checkbox").attr('checked', false);
		} // End else {
	} // End function check_profilerToggleCheckbox(a) {


function check_profiler_perform_action(action) {
	//alert('Action = ' + action);

	check_profiler_ajaxSetup();

	// Get the username selected
	var username = $('#id_bcuan').val();
	//alert('Username = ' + username);

	// Get the password selected
	var password = $('#id_bcuap').val();
	//alert('Password = ' + password);
	
	// Define the DIV ID we are going to load
	var div_id = '#check_profiler_' + action + '_objects';

	// Hide the DIV
	$(div_id).hide();
	
	// Show the Throbber DIV
	$(div_id + '_throbber').show();
	
	// Load the DIV
	$(div_id).load('/nagiosxi/includes/components/check_profiler/check_profiler_do_stuff.php?request=' + action + '&username=' + username + '&password=' + password);	

	// Hide the Throbber DIV
	$(div_id + '_throbber').hide();
	
	// Show the DIV
	$(div_id).show();

	// Sort the table
	switch (action) {
		case 'host':
			check_profiler_SortTable("check_profiler_table_host_summary");
			break; // End case 'host':

		case 'service':
			check_profiler_SortTable("check_profiler_table_service_summary");
			check_profiler_SortTable("check_profiler_table_service_all");
			break; // End case 'service':
		} // End switch (action) {
	
	} // End function check_profiler_perform_action(action) {


function check_profiler_SortTable(input_request) {
	//alert('input_request = ' + input_request);
	switch (input_request) {
		case 'check_profiler_table_host_summary':
			$('#' + input_request).tablesorter( {sortList: [[1,1], [2,1]], widgets: ['zebra']} );
			break; // End case 'check_profiler_table_host_summary':

		case 'check_profiler_table_service_summary':
			$('#' + input_request).tablesorter( {sortList: [[2,1], [3,1]], widgets: ['zebra']} );
			break; // End case 'check_profiler_table_service_summary':

		case 'check_profiler_table_service_all':
			$('#' + input_request).tablesorter( {sortList: [[2,1], [3,1]], widgets: ['zebra']} );
			break; // End case 'check_profiler_table_service_all':
		} // End switch (input_request) {
	} // End function check_profiler_SortTable(input_request) {
