<?php  
// check_profiler_do_stuff COMPONENT
//
// Copyright 2016-04-01 Troy Lea aka Box293
//

require_once(dirname(__FILE__).'/../../common.inc.php');

// initialization stuff
pre_init();
// start session
init_session();
// grab GET or POST variables 
grab_request_vars();
// check prereqs
check_prereqs();
// check authentication
check_authentication(false);


/* Get the request passed to us */
$check_profiler_request = grab_request_var('request',false);

/* Get the username passed to us */
$check_profiler_username = urldecode(unserialize(base64_decode(grab_request_var('username',false))));
//print_r($check_profiler_username . '<br/>');

/* Get the password passed to us */
$check_profiler_password = urldecode(unserialize(base64_decode(grab_request_var('password',false))));
//print_r($check_profiler_password . '<br/>');

/* Get the base url and remove the last three characters from the end (xi/)*/
$base_url = substr(get_base_url(), 0, -3);
//print_r($base_url . '<br />');

$json_url = $base_url . '/cgi-bin/statusjson.cgi?';
//print_r($json_url . '<br />');

/* Need to allow timeout to be defined through component admin */
$curl_timeout = 20;

/* Process the request */
switch ($check_profiler_request) {
	case 'host':
		/* Define the query for the JSON request */
		$json_query = 'query=hostlist&details=true';

		/* Call the function to perform the query */
		$query_data = check_profiler_json_query_perform($json_url, $json_query, $check_profiler_username, $check_profiler_password, $curl_timeout);
		//print_r($query_data . '<br />');

		/* Check to make sure the returned data is an array */
		if (!is_array($query_data)) {
			$html = '
				<div class="check_profiler_spacer5"> </div>
				<div class="check_profiler_font_weight_bold">Uh Oh</div>
				<div class="check_profiler_spacer20"> </div>
				Something went wrong, probably with the JSON query. Send me an email and I\'ll look into what is happeneng and fix it!
				';
			} /* End if (!is_array($query_data)) { */
		else {
			/* Call the function to process the data */
			$processed_data = check_profiler_process_query($query_data, 'hostlist');

			/* Create the tables */
			$table_host_summary = '
				<table id="check_profiler_table_host_summary" class="tablesorter">
					<thead><tr><th>Host</th><th>Execution Time</th><th>Latency</th><th>Last Hard State</th></tr></thead>
				';

			foreach($processed_data as $check_key => $check_array) {
				foreach ($check_array as $host_key => $host_array) {
					/* Summary Table */
					$table_host_summary .= '<tr>';
					/* Add the check cell */
					$table_host_summary .= '<td>'.$check_key.'</td>';
					/* Define the averages */
					$execution_time_average = 0;
					$latency_average = 0;
					/* Add the execution time cell */
					$table_host_summary .= '<td>'.$check_array[$host_key]['execution_time'].'</td>';
					/* Add the latency cell */
					$table_host_summary .= '<td>'.$check_array[$host_key]['latency'].'</td>';
					/* Add the last hard state cell */
					//$table_host_summary .= '<td>'.check_profiler_state('host', $check_array[$host_key]['last_hard_state']).'</td>';
					$table_host_summary .= check_profiler_state('host', $check_array[$host_key]['last_hard_state']);
					$table_host_summary .= '</tr>';
					} /* End foreach ($check_array as $host_key => $host_array) { */
				} /* End foreach($processed_data as $check_key => $check_array) { */		

			/* Summary Table */
			$table_host_summary .= '</table>';

			/* Output the results */
			$html = '
				<div class="check_profiler_font_weight_bold">Hosts Summary</div>
				<div class="check_profiler_spacer10"> </div>
				'.$table_host_summary.'
				';
			} /* End else { */
		
		print $html;
		break; /* End case 'host': */
	

	case 'service':
		/* Define the query for the JSON request */
		$json_query = 'query=servicelist&details=true';

		/* Call the function to perform the query */
		$query_data = check_profiler_json_query_perform($json_url, $json_query, $check_profiler_username, $check_profiler_password, $curl_timeout);
		//print_r($query_data . '<br />');

		/* Check to make sure the returned data is an array */
		if (!is_array($query_data)) {
			$html = '
				<div class="check_profiler_spacer5"> </div>
				<div class="check_profiler_font_weight_bold">Uh Oh</div>
				<div class="check_profiler_spacer20"> </div>
				Something went wrong, probably with the JSON query. Send me an email and I\'ll look into what is happeneng and fix it!
				';
			} /* End if (!is_array($query_data)) { */
		else {
			/* Call the function to process the data */
			$processed_data = check_profiler_process_query($query_data, 'servicelist');

						/* Create the tables */
			$table_service_summary = '
				<table id="check_profiler_table_service_summary" class="tablesorter">
					<thead><tr><th>Check</th><th>Count</th><th>Execution Time Average</th><th>Latency Average</th></tr></thead>
				';

			$table_service_all = '
				<table id="check_profiler_table_service_all" class="tablesorter">
					<thead><tr><th>Check</th><th>Host</th><th>Execution Time</th><th>Latency</th><th>Last Hard State</th></tr></thead>
				';

			foreach($processed_data as $check_key => $check_array) {
				$check_flag = 0;
				foreach ($check_array as $host_key => $host_array) {
					/* Is this the first check in the check array */
					if ($check_flag == 0) {
						/* Summary Table */
						$table_service_summary .= '<tr>';
						/* Add the check cell */
						$table_service_summary .= '<td>'.$check_key.'</td>';
						/* Add the count cell */
						$table_service_summary .= '<td>'.count($check_array).'</td>';
						/* Define the averages */
						$execution_time_average = 0;
						$latency_average = 0;
						for ($i=0; $i <= count($check_array); $i++) {
							$execution_time_average += $check_array[$host_key]['execution_time'];
							$latency_average += $check_array[$host_key]['latency'];
							} /* End for ($i=0; $i <= count($check_array); $i++) { */
						$execution_time_average = number_format($execution_time_average / count($check_array), 2, '.', ',');
						$latency_average = number_format($latency_average / count($check_array), 2, '.', ',');
						/* Add the execution average cell */
						$table_service_summary .= '<td>'.$execution_time_average.'</td>';
						/* Add the latency average cell */
						$table_service_summary .= '<td>'.$latency_average.'</td>';
						$table_service_summary .= '</tr>';

						/* All Table */
						$table_service_all .= '<tr>';
						/* Add the check cell */
						$table_service_all .= '<td>'.$check_key.'</td>';
						/* Add the host cell */
						$table_service_all .= '<td>'.$host_key.'</td>';
						/* Add the execution cell */
						$table_service_all .= '<td>'.$host_array['execution_time'].'</td>';
						/* Add the latency cell */
						$table_service_all .= '<td>'.$host_array['latency'].'</td>';
						/* Add the last hard state cell */
						$table_service_all .= check_profiler_state('service', $host_array['last_hard_state']);
						$table_service_all .= '</tr>';
						} /* End if ($check_flag == 0) { */
					else {
						/* All Table */
						$table_service_all .= '<tr>';
						/* Add the check cell */
						$table_service_all .= '<td>'.$check_key.'</td>';
						/* Add the host cell */
						$table_service_all .= '<td>'.$host_key.'</td>';
						/* Add the execution cell */
						$table_service_all .= '<td>'.$host_array['execution_time'].'</td>';
						/* Add the latency cell */
						$table_service_all .= '<td>'.$host_array['latency'].'</td>';
						/* Add the last hard state cell */
						$table_service_all .= check_profiler_state('service', $host_array['last_hard_state']);
						$table_service_all .= '</tr>';
						} /* End else { */
					$check_flag++;
					} /* End foreach ($check_array as $host_key => $host_array) { */
				} /* End foreach($processed_data as $check_key => $check_array) { */		

			/* Summary Table */
			$table_service_summary .= '</table>';

			/* All Table */
			$table_service_all .= '</table>';

			/* Output the results */
			$html = '
				<div class="check_profiler_font_weight_bold">Services Summary</div>
				<div class="check_profiler_spacer10"> </div>
				'.$table_service_summary.'
				<div class="check_profiler_spacer20"> </div>
				<div class="check_profiler_font_weight_bold">All Services</div>
				<div class="check_profiler_spacer10"> </div>
				'.$table_service_all.'
				';

			} /* End else { */
		
		print $html;
		break; /* End case 'service': */
	} /* End switch ($check_profiler_request) { */


/* FUNCTIONS */

function check_profiler_state($type, $state) {
	switch ($type) {
		case 'host':
			$state_value = '<td class="check_profiler_host_';
			switch ($state) {
				case '0':
					$state_value .= 'up">UP';
					break; /* End case '0': */
				
				case '1':
					$state_value .= 'down">DOWN';
					break; /* End case '1': */
				
				case '2':
					$state_value .= 'unreachable">UNREACHABLE';
					break; /* End case '2': */
				} /* End switch ($state) { */
			$state_value .= '</td>';
			break; /* End case 'host': */


		case 'service':
			$state_value = '<td class="check_profiler_service_';
			switch ($state) {
				case '0':
					$state_value .= 'ok">OK';
					break; /* End case '0': */
				
				case '1':
					$state_value .= 'warning">WARNING';
					break; /* End case '1': */
				
				case '2':
					$state_value .= 'critical">CRITICAL';
					break; /* End case '2': */
				
				case '3':
					$state_value .= 'unknown">UNKNOWN';
					break; /* End case '3': */
				} /* End switch ($state) { */
			$state_value .= '</td>';
			break; /* End case 'service': */
		} /* End switch ($type) { */

	return $state_value;
	} /* End function check_profiler_state($type, $state) { */


function check_profiler_json_query_perform($json_url, $json_query, $json_username, $json_password, $curl_timeout) {
	$ssl_test = substr($json_url, 0, 5);
	if ($ssl_test == 'https') {
		$ssl_used = 1;
		} /* End if ($ssl_test == 'https') { */
	else {
		$ssl_used = 0;
		} /* End else { */
	
	/* Define the curl options */
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $json_url.$json_query);
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_USERPWD, "$json_username:$json_password");
	curl_setopt($ch, CURLOPT_TIMEOUT, $curl_timeout);
	if ($ssl_used == 1) {
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		} /* End if ($ssl_used == 1) { */

	/* Execute the Curl Request */
	$curl_output = curl_exec($ch);

	/* Get the Curl Info */
	$curl_info = curl_getinfo($ch);

	/* Close the Curl handle */
	curl_close($ch);

	/* Determine if the test suceeded or failed */
	if ($curl_info['http_code'] == 200) {
		/* Turn the output into an array */
		$query_data = json_decode($curl_output, true);
		} /* End if ($curl_info['http_code'] == 200) { */
	else {
		$query_data = 'The JSON query failed. Ensure the user credentials are correctly defined in the Box293 Common User Account component!';
		} /* End else { */

	return $query_data;
	} /* End function check_profiler_json_query_perform($json_url, $json_query, $json_username, $json_password, $curl_timeout) { */


function check_profiler_process_query($query_data, $query_type) {
	/* Now process the data and add it to a new array */
	$processed_data = array();

	if ($query_data['result']['type_text'] == 'Success') {
		/* The query was a success */
		//print_r('Query Result: ' . $query_data['result']['type_text'] . '<br />');
		switch ($query_type) {
			case 'hostlist':
				if (isset($query_data['data'][$query_type])) {
					/* This is a hostlist query */
					if (count($query_data['data'][$query_type]) > 0) {
						/* There is at least 1 host */
						foreach ($query_data['data'][$query_type] as $host_key => $host_array) {
							//print_r('host_key: ' . $host_key . '<br />');
							if (count($host_array) > 0) {
								/* There is at least 1 host */
								//print_r('_host_key: ' . $host_key . '<br />');
								//print_r('__execution_time: ' . $host_array['execution_time'] . '<br />');
								//print_r('__latency: ' . $host_array['latency'] . '<br />');
								$processed_data[$host_key][$host_key]['execution_time'] = $host_array['execution_time'];
								$processed_data[$host_key][$host_key]['latency'] = $host_array['latency'];
								$processed_data[$host_key][$host_key]['last_hard_state'] = $host_array['last_hard_state'];
								} /* End if (count($host_array) > 0) { */
							} /* End foreach ($query_data['data'][$query_type] as $host_key => $host_array) { */
						} /* End if (count($query_data['data'][$query_type]) > 0) { */
					} /* End if (isset($query_data['data'][$query_type])) { */
				break; /* End case 'hostlist': */

			case 'servicelist':
				if (isset($query_data['data'][$query_type])) {
					/* This is a servicelist query */
					if (count($query_data['data'][$query_type]) > 0) {
						/* There is at least 1 host */
						foreach ($query_data['data'][$query_type] as $host_key => $host_array) {
							//print_r('host_key: ' . $host_key . '<br />');
							if (count($host_array) > 0) {
								/* There is at least 1 service */
								foreach ($host_array as $service_key => $service_array) {
									//print_r('_service_key: ' . $service_key . '<br />');
									//print_r('__execution_time: ' . $service_array['execution_time'] . '<br />');
									//print_r('__latency: ' . $service_array['latency'] . '<br />');
									$processed_data[$service_key][$host_key]['execution_time'] = $service_array['execution_time'];
									$processed_data[$service_key][$host_key]['latency'] = $service_array['latency'];
									$processed_data[$service_key][$host_key]['last_hard_state'] = $service_array['last_hard_state'];
									} /* End foreach ($host_array as $service_key => $service_array) { */
								} /* End if (count($host_array) > 0) { */
							} /* End foreach ($query_data['data'][$query_type] as $host_key => $host_array) { */
						} /* End if (count($query_data['data'][$query_type]) > 0) { */
					} /* End if (isset($query_data['data'][$query_type])) { */
				break; /* End case 'servicelist': */
			} /* End switch ($query_type) { */
		} /* End if ($query_data['result']['type_text'] == 'Success') { */

	return $processed_data;
	} /* End function check_profiler_process_query($query_data, $query_data) { */
